<template>
  <q-layout view="hHh lpR fFf">
    <q-page-container>
      <q-header elevated>
        <Toolbar :hasBackButton="true" :pageTitle="$t('contacts.page_title')" />
      </q-header>

      <q-page class="pl-fullpage">
        <h6 class="q-my-md">
          Allowed users and domains
        </h6>
        <q-list separator style="margin-bottom:60px">
          <q-item v-for="dom in replacedCommas.domains || {}" :key="dom">
            <q-item-section>
              <q-item-label> {{ dom }} </q-item-label>
            </q-item-section>
          </q-item>
          <div v-if="!domains">
            No domains allowed
          </div>
        </q-list>

        <q-form ref="formRef" @submit="addDomain">
          <q-input label="Domain (e.g. 'monash.edu'). NO PUBLIC + FREE EMAIL PROVIDERS" filled v-model="domainInput"
            style="display: inline-block; width: 90%;" />
          <q-btn type="submit" color="primary" rounded>
            Add Domain
          </q-btn>
        </q-form>


        <q-list separator style="margin-bottom:60px">
          <q-item v-for="email in replacedCommas.emails || {}" :key="email">
            <q-item-section>
              <q-item-label> {{ email }} </q-item-label>
            </q-item-section>
          </q-item>
          <div v-if="!replacedCommas.emails">
            No email addresses allowed
          </div>
        </q-list>

        <q-form ref="formRef" @submit="addEmail">
          <q-input label="Email address (e.g. 'test@gmail.com')" filled v-model="emailInput"
            style="display: inline-block; width: 90%;" />
          <q-btn type="submit" color="primary" rounded>
            Add email address
          </q-btn>
        </q-form>

      </q-page>

    </q-page-container>
  </q-layout>
</template>
<script>
import { db, functions } from "../../firebase";
import Toolbar from "../../components/Toolbar.vue";

export default {
  data()
  {
    return {
      domains: undefined,
      domainInput: "",
      emails: undefined,
      emailInput: ""
    };
  },
  computed: {
    // can't store strings with periods as keys
    replacedCommas()
    {
      let domains = [];
      for (const dom in this.domains)
      {
        domains.push(dom.replaceAll(',', '.'))
      }

      let emails = [];
      for (const email in this.emails)
      {
        domains.push(email.replaceAll(',', '.'))
      }
      return {
        'domains': domains, 'emails': emails
      }
    }
  },
  methods: {
    addDomain()
    {
      const fbFunction = functions.httpsCallable("addAllowedDomain");
      fbFunction({
        Domain: this.domainInput
      });
    },
    addEmail()
    {
      const fbFunction = functions.httpsCallable("addAllowedEmail");
      fbFunction({
        Email: this.emailInput
      });
    }
  },
  created()
  {
    this.$rtdbBind("domains", db.ref('System/Allowed/Domains')).then(
      (val) => console.log(val.val())
    );
    this.$rtdbBind("emails", db.ref('System/Allowed/Emails')).then(
      (val) => console.log(val.val())
    );
  },
  components: {
    Toolbar
  },
};
</script>
